#open "prelude";;
#open "output";;
#open "maple";;

let to_cite = ref ["Knuth73"];;

let bibliography = [("Zimmermann91","P. Zimmermann, Se'ries ge'ne'ratrices et analyse automatique\n\td'algorithmes, E'cole Polytechnique, the`se de doctorat, 1991.");
("Soria90","M. Soria, Me'thodes d'analyse pour les constructions combinatoires\n\tet les algorithmes, Universite' de Paris-Sud, the`se d'Etat, 1990.")];;

let cite s = if not mem s !to_cite then to_cite := s :: !to_cite; ();;

let biblio () = 
   to_cite := union !to_cite (words(to_maple "`luo/citations`()"));
   if !to_cite<>[] & !printlevel>=2 then
	(print_string "References:\n";
	map (fun s -> print_string (" ["^s^"] "^assoc s bibliography^"\n"))
		!to_cite;());
   to_cite := []
;;

